
/*
 * Aktueller Stand
 *
 *   $RCSfile: Constraints.cc,v $
 *   $Revision: 1.7 $
 *   $Date: 1998/08/14 13:20:10 $
 *   $Author: myritz $ 
 *
 */
 
#include "Constraints.h"
#include "InvalidIdException.h"
#include "String.h"
 
Constraint *getConstraintWithId( int constraintId )
{
  Constraint *newConstraint;
  switch ( constraintId ) {
    case UNDEF_CONSTRAINT_ID:
      newConstraint = new Constraint();
      break;
    case CONSERVE_STAMINA_CONSTRAINT_ID:
      newConstraint = new ConserveStaminaConstraint();
      break;
    case AVOID_OFFSIDE_CONSTRAINT_ID:
      newConstraint = new AvoidOffsideConstraint();
      break;
    default:
      throwException( InvalidIdException("Invalid id in constraintWithId.") );
  }
  return newConstraint;
}

Array<int> constraintIds()
{
  Array<int> ids;
  ids.addObject( CONSERVE_STAMINA_CONSTRAINT_ID );
  ids.addObject( AVOID_OFFSIDE_CONSTRAINT_ID );
  return ids;
}
