
/*
 * Aktueller Stand
 *
 *   $RCSfile: ControlBallOption.cc,v $
 *   $Revision: 1.7 $
 *   $Date: 1998/08/14 13:20:11 $
 *   $Author: myritz $ 
 *
 */
 
#include "ControlBallOption.h"
#include "Constraints.h"
#include "WorldModel.h"
#include "Skills.h"

ControlBallOption::ControlBallOption() : KickOption() 
{
  theId = CONTROL_BALL_OPTION_ID;
}  


int ControlBallOption::baseUtility() const 
{
  INFO( Log::ACTIVE_OPTIONS, 2, "ENTER ControlBallOption::baseUtility\n" );
  int bestUtility = KickOption::baseUtility();
  if ( bestUtility == MAX_UTILITY ) {
    // Es liegt eine Kick-Situation vor. Jetzt genaue Werte ausrechnen.
    
    // Szenario vorbereiten
    Situation scenario( globalWorldModel->situation() );
    ModelledBall ball = scenario.ball();
    ModelledPlayer player = scenario.playerWithId( globalWorldModel->id() );
    
    int i;
    bestUtility = NEUTRAL_UTILITY;
    ModelledPlayer otherPlayer;
    theIsBallInRangeOfOtherPlayer = NO;
    for (i = 0; i < scenario.playerCount(); i++ ) {
      otherPlayer = scenario.playerWithIndex( i );
      if ( ( otherPlayer.id() != globalWorldModel->id() ) &&
          ( ball.isInKickRangeOfPlayer( otherPlayer ) == YES ) ) {
        bestUtility = globalConf->maxControlBallUtility;
        theIsBallInRangeOfOtherPlayer = YES;
        INFO( Log::ACTIVE_OPTIONS, 8, "Spieler " + String( otherPlayer.id() ) +
          " kann auch kicken.\n" );
        break;
      }
    }
  }
  else {
    // nichts machen. Die default-Werte sind ausreichend.
  }
  
  INFO( Log::ACTIVE_OPTIONS, 8, "Utility : " + String( bestUtility ) + "\n" );
  return bestUtility;
}

Plan ControlBallOption::generatePlan() const 
{
  if ( isPossible() == NO ) {
    return Plan();
  }
  else {
    Plan plan;
    globalSkills->resetSituation();
    plan.addPlan( globalSkills->setViewWidth( VIEW_WIDTH_NARROW ) );
    plan.addPlan( globalSkills->gainBallControl() );
    return plan;
  }
}

bool ControlBallOption::isPossible() const 
{
  // Wir gehen davon aus, dass sich der Ball in unserem Kickradius befindet.
  expectedUtility(); // setzt auf alle Faelle theIsBallInRangeOfOtherPlayer
  return theIsBallInRangeOfOtherPlayer;
}



StorableObject* ControlBallOption::copy() const 
{
  return new ControlBallOption( *this );
}

String ControlBallOption::toString() const  
{
  return String( "( ControlBallOption utility: " ) +
    String( expectedUtility() ) + String( " ) " );
}



 



