
#include "Plan.h"
#include "Configuration.h"

Plan::Plan() {
  theActions = Array<Action>(globalConf->maxLengthOfPlan);
}

Plan::Plan(int length) {
  theActions = Array<Action>(length);
}

Plan::~Plan() {
}

void Plan::addPlan( const Plan& newPlan ) 
{
  for( int index = 0; index < newPlan.length(); index++ ) {
    theActions.addObject( newPlan.actionAt( index ) );
  }
}

StorableObject* Plan::copy() const {
  return new Plan( *this );
}

String Plan::toString() const 
{
  String output = "\n( Plan actions: ";
  
  for ( int i = 0; i < theActions.count(); i++ ) {
    output = output + "\n" + String( i ) + ".: " + actionAt( i ).toString();
  }
  return output;
}

